package com.keyboard.themes.key.mykeyboard;

import android.annotation.SuppressLint;
import android.graphics.drawable.Drawable;
import android.inputmethodservice.InputMethodService;

import android.media.MediaPlayer;
import android.util.Log;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputConnection;
import android.widget.ImageView;
import android.widget.VideoView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bumptech.glide.Glide;
import com.bumptech.glide.integration.webp.decoder.WebpDrawable;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.Target;
import com.keyboard.themes.key.AppThemes;
import com.keyboard.themes.key.R;
import com.keyboard.themes.key.utils.ConstKey;
import com.keyboard.themes.key.utils.MyUtils;
import com.keyboard.themes.key.utils.Store;
import com.keyboard.themes.key.rescode.CusKeyBoard;
import com.keyboard.themes.key.rescode.CusKeyBoardView;


import kotlin.Unit;
import kotlin.jvm.functions.Function2;

public class MyInputMethodService extends InputMethodService implements CusKeyBoardView.OnKeyboardActionListener {


    private MyInputView myInputView;
    private CusKeyBoard mKeyBoard;
    private View parentView;


    private ImageView imBG;
    private VideoView videoView;
    
    private int a = R.xml.xml1;
    private int b= R.xml.xml2;
    private int c = R.xml.xml3;

    private int curImeAction = EditorInfo.IME_ACTION_UNSPECIFIED;
    @SuppressLint("InflateParams")
    @Override
    public View onCreateInputView() {
        parentView = getLayoutInflater().inflate(R.layout.theme_layout_input_view, null);
        findView();
        return parentView;
    }

    private void findView() {

        imBG = parentView.findViewById(R.id.gif_bg);
        videoView = parentView.findViewById(R.id.video_view);
        mKeyBoard = new CusKeyBoard(this, a);
        myInputView = parentView.findViewById(R.id.custom_input_view);
        myInputView.setEnabled(true);
        myInputView.setPreviewEnabled(false);
        myInputView.setKeyboard(mKeyBoard);
        myInputView.setOnKeyboardActionListener(this);
    }


    @Override
    public void onWindowHidden() {
        super.onWindowHidden();
        if(videoView.isPlaying()){
            videoView.pause();

        }
    }

    @Override
    public void onWindowShown() {
        super.onWindowShown();
        EditorInfo currentInputEditorInfo = getCurrentInputEditorInfo();
        curImeAction = MyUtils.INSTANCE.getTextForImeAction(currentInputEditorInfo.imeOptions);
        String skinPath = Store.INSTANCE.getSkinPath();

        if(skinPath == null || skinPath.isEmpty()){
            Log.d(AppThemes.TAG, "---------skinPath= bull");
            myInputView.updateUi(curImeAction);
        }else {
            Log.d(AppThemes.TAG, "---------skinPath= 1111");
            KeyFunction.INSTANCE.readBgOrVideo(this, new Function2<String, Drawable, Unit>() {
                @Override
                public Unit invoke(String s, Drawable drawable) {
                    Log.d(AppThemes.TAG, "---------s= "+s+"---------drawable="+drawable);
                    if (s != null) {
                        myInputView.setBackground(null);
                        if(s.endsWith(".gif")){
                            imBG.setVisibility(View.VISIBLE);
                            videoView.setVisibility(View.GONE);
                            Glide.with(MyInputMethodService.this)
                                    .load(s)
                                    .addListener(new RequestListener<Drawable>() {
                                        @Override
                                        public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                                            return false;
                                        }

                                        @Override
                                        public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                                            if (resource instanceof WebpDrawable) {
                                                ((WebpDrawable) resource).setLoopCount(WebpDrawable.LOOP_FOREVER);
                                            }
                                            return false;
                                        }
                                    }).into(imBG) ;
                        }else if(s.endsWith(".mp4")){
                            imBG.setVisibility(View.GONE);
                            videoView.setVisibility(View.VISIBLE);
                            videoView.setVideoPath(s);
                            videoView.start();
                            videoView.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                                @Override
                                public void onPrepared(MediaPlayer mp) {
                                    mp.setLooping(true);
                                }
                            });
                        }

                    } else {
                        myInputView.setBackground(drawable);
                    }
                    myInputView.updateUi(curImeAction);
                    return null;
                }
            });
        }


    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        videoView.stopPlayback();
    }

    @Override
    public void onPress(int primaryCode) {

    }

    @Override
    public void onRelease(int primaryCode) {

    }

    @Override
    public void onKey(int primaryCode, int[] keyCodes) {

        InputConnection curInputConnect = getCurrentInputConnection();
        switch (primaryCode) {
            case ConstKey.KEY_CODE_DELETE:
                curInputConnect.deleteSurroundingText(1, 0);
                break;
            case ConstKey.KEY_CODE_SHIFT:
                switchShift();
                break;
            case ConstKey.KEY_CODE_NUMBER_SHIFT:
            case ConstKey.KEY_CODE_SYMBOL_SHIFT:
                switchMoreOrNumber();
                break;
            case ConstKey.KEY_CODE_CHANGE_NUMBER:
            case ConstKey.KEY_CODE_BACK:
                switchNormalOrNumber();
                break;

            case ConstKey.KEY_CODE_COMPLETE:
            case ConstKey.KEY_CODE_CANCEL:
                curInputConnect.performEditorAction(curImeAction);
//                curInputConnect.performEditorAction(EditorInfo.IME_ACTION_DONE);
                break;
            default:
                String codeToChar = KeyFunction.INSTANCE.primaryCodeToChar(primaryCode);
                curInputConnect.commitText(codeToChar, 1);
                if (myInputView.isLowerCase() == 1) {
                    //自动转小写
                    myInputView.setLowerCase(0);
                    KeyFunction.INSTANCE.keyToLowerCase(mKeyBoard);
                    myInputView.setKeyboard(mKeyBoard);
                }
                break;

        }


    }

    private void switchMoreOrNumber() {
        int mode = myInputView.getMode();
        switch (mode) {
            case 1:
                mKeyBoard = new CusKeyBoard(this, c);
                myInputView.setMode(2);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 2:
                mKeyBoard = new CusKeyBoard(this, b);
                myInputView.setMode(1);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchNormalOrNumber() {
        int mode = myInputView.getMode();
        switch (mode) {
            case 0:
                mKeyBoard = new CusKeyBoard(this, b);
                myInputView.setMode(1);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 1:
            case 2:
                mKeyBoard = new CusKeyBoard(this, a);
                myInputView.setMode(0);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchShift() {
        int lowerCase = myInputView.isLowerCase();
        switch (lowerCase) {
            case 0:
                //当前小写转大写
                myInputView.setLowerCase(1);
                KeyFunction.INSTANCE.keyToUpper(mKeyBoard);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 1:
                //当前大写转锁定大写
                myInputView.setLowerCase(2);
                break;
            case 2:
                //当前锁定大写转小写
                myInputView.setLowerCase(0);
                KeyFunction.INSTANCE.keyToLowerCase(mKeyBoard);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }
    }


    @Override
    public void onText(CharSequence text) {

    }

    @Override
    public void swipeLeft() {

    }

    @Override
    public void swipeRight() {

    }

    @Override
    public void swipeDown() {

    }

    @Override
    public void swipeUp() {

    }


}
